﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using HeuristicLab.Services.Optimization.Billing.Interfaces;
using HeuristicLab.Services.Optimization.Billing.Business;
using HeuristicLab.Services.Optimization.Billing;
using HeuristicLab.Services.Optimization.Billing.Model;
using HeuristicLab.Services.Optimization.Web.Models;
using HeuristicLab.Services.Optimization.Web.Helpers;

namespace HeuristicLab.Services.Optimization.Web.Controllers {
  [BillingFilterActionAttribute]
  public class InvoiceController : BaseController {
    private IOptimizationBilling billing = BillingServiceProvider.Instance;

    //
    // GET: /Invoice/

    public ActionResult Index() {
      if (RedirectToLoginIfNecessary("%2fInvoice", false)) {
        return View();
      }
      var invoice = billing.GetInvoices(UserName);
      return View(new InvoiceModel() {
         PaidInvoices = (from i in invoice where i.Status == InvoiceStatus.Paid select i).ToList(),
         OpenInvoices = (from i in invoice where i.Status == InvoiceStatus.Open select i).ToList(),
         OverdueInvoices = (from i in invoice where i.Status == InvoiceStatus.Overdue select i).ToList()
      });
    }

  }
}
